// file      : xsde/cxx/parser/validating/qname.hxx
// author    : Boris Kolpackov <boris@codesynthesis.com>
// copyright : Copyright (c) 2005-2007 Code Synthesis Tools CC
// license   : GNU GPL v2 + exceptions; see accompanying LICENSE file

#ifndef XSDE_CXX_PARSER_VALIDATING_QNAME_HXX
#define XSDE_CXX_PARSER_VALIDATING_QNAME_HXX

#include <xsde/cxx/string.hxx>

#include <xsde/cxx/parser/validating/xml-schema-pskel.hxx>

namespace xsde
{
  namespace cxx
  {
    namespace parser
    {
      namespace validating
      {
        struct qname_pimpl: virtual qname_pskel
        {
          virtual void
          _pre ();

          virtual void
          _characters (const ro_string&);

          virtual void
          _post ();

          virtual qname*
          post_qname ();

        protected:
          string str_;
          string name_;
          string prefix_;
        };
      }
    }
  }
}

#endif  // XSDE_CXX_PARSER_VALIDATING_QNAME_HXX
