// file      : xsde/cxx/serializer/name-processor.hxx
// author    : Boris Kolpackov <boris@codesynthesis.com>
// copyright : Copyright (c) 2006-2007 Code Synthesis Tools CC
// license   : GNU GPL v2 + exceptions; see accompanying LICENSE file

#ifndef CXX_SERIALIZER_NAME_PROCESSOR_HXX
#define CXX_SERIALIZER_NAME_PROCESSOR_HXX

#include <cult/types.hxx>
#include <xsd-frontend/semantic-graph.hxx>

namespace CXX
{
  namespace Serializer
  {
    using namespace Cult::Types;

    class NameProcessor
    {
    public:
      Void
      process (XSDFrontend::SemanticGraph::Schema&,
               XSDFrontend::SemanticGraph::Path const& file,
               Boolean assign_impl_name,
               WideString const& skel_type_suffix,
               WideString const& impl_type_suffix);
    };
  }
}

#endif // CXX_SERIALIZER_NAME_PROCESSOR_HXX
